.386
.model flat,stdcall
option casemap:none

include TimeBreak.inc

.code

start:

	invoke GetModuleHandle,NULL
	mov    hInstance,eax
	invoke GetCommandLine
	invoke InitCommonControls
	mov		CommandLine,eax
	invoke WinMain,hInstance,NULL,CommandLine,SW_SHOWDEFAULT
	invoke ExitProcess,eax

WinMain proc hInst:HINSTANCE,hPrevInst:HINSTANCE,CmdLine:LPSTR,CmdShow:DWORD
	LOCAL	wc:WNDCLASSEX
	LOCAL	msg:MSG

	mov		wc.cbSize,sizeof WNDCLASSEX
	mov		wc.style,CS_HREDRAW or CS_VREDRAW
	mov		wc.lpfnWndProc,offset WndProc
	mov		wc.cbClsExtra,NULL
	mov		wc.cbWndExtra,DLGWINDOWEXTRA
	push	hInst
	pop		wc.hInstance
	mov		wc.hbrBackground,COLOR_BTNFACE+1
	mov		wc.lpszMenuName,NULL ;IDM_MENU
	mov		wc.lpszClassName,offset ClassName
	invoke LoadIcon,NULL,IDI_APPLICATION
	mov		wc.hIcon,eax
	mov		wc.hIconSm,eax
	invoke LoadCursor,NULL,IDC_ARROW
	mov		wc.hCursor,eax
	invoke RegisterClassEx,addr wc
	invoke CreateDialogParam,hInstance,IDD_DIALOG,NULL,addr WndProc,NULL
	invoke ShowWindow,hWnd,SW_SHOWNORMAL
	invoke UpdateWindow,hWnd
	.while TRUE
		invoke GetMessage,addr msg,NULL,0,0
	  .BREAK .if !eax
		invoke TranslateMessage,addr msg
		invoke DispatchMessage,addr msg
	.endw
	mov		eax,msg.wParam
	ret

WinMain endp

; -----------------------------------------------------------------
; TimerFunc
; Interval: Length to set timer (in milliseconds)
; Return: None
; Creates a timer for the specified Interval
; ------------------------------------------------------------------
TimerFunc proc Interval:DWORD
	invoke SetTimer, NULL, 1, Interval, NULL ; Create the timer with length based on Interval
	
	.if ax==0 ; Something bad happened...what is it?
		invoke MessageBox,NULL, addr FailedCreateTimer, addr AppName, MB_OK ; Well, we couldn't create the timer...so we inform the user
	.endif
	ret ; Exit function

TimerFunc endp

; -----------------------------------------------------------------
; ForceWindowTop
; hWin: Handle to window
; W: Current widht of window
; Return: None
; Forces the window (defined by hWin) to be on top of all other windows.
; Credit:
; Borrowed from Farabi at the MASM32 Forums
;    http://www.masm32.com/board/index.php?topic=7336.0
; ------------------------------------------------------------------
ForceWindowTop proc hWin:HWND,W:DWORD,H:DWORD
	LOCAL xs,ys,hxs,hys:DWORD ; Define some local variables
	
	invoke GetSystemMetrics,SM_CXSCREEN ; First, we'll get the X-position variables for the window
	
	mov xs, eax ; Store the variable in xs, drop the first bit (bit 0), then store another variable
	shr eax, 1
	mov hxs, eax
	
	invoke GetSystemMetrics,SM_CYSCREEN ; Now get the Y-position variables for the window
	
	mov ys, eax ; Repeat the process
	shr eax, 1
	mov hys, eax
	
	; SetWindowPos - handle to window, type of window it should be set to, current x and y positions, and window type
	; HWND_TOPMOST means it will be a pain in the ass (can only exit out or minimize)
	; SWP_NOSIZE means to ignore the cx & cy variables (thus why they are both set to 0
	invoke SetWindowPos,hWin, HWND_TOPMOST, hxs, hys, 0, 0, SWP_NOSIZE
	ret
ForceWindowTop endp

; -----------------------------------------------------------------
; NoForceWindowTop
; hWin: Handle to window
; W: Current widht of window
; Return: None
; Removes the flags forcing a window to stay on top of others
; Credit:
; Borrowed from Farabi at the MASM32 Forums
;    http://www.masm32.com/board/index.php?topic=7336.0
; ------------------------------------------------------------------
NoForceWindowTop proc hWin:HWND,W:DWORD,H:DWORD
	LOCAL xs,ys,hxs,hys:DWORD ; Define some local variables
	
	invoke GetSystemMetrics,SM_CXSCREEN ; First, we'll get the X-position variables for the window
	
	mov xs, eax ; Store the variable in xs, drop the first bit (bit 0), then store another variable
	shr eax, 1
	mov hxs, eax
	
	invoke GetSystemMetrics,SM_CYSCREEN ; Now get the Y-position variables for the window
	
	mov ys, eax ; Repeat the process
	shr eax, 1
	mov hys, eax
	
	; SetWindowPos - handle to window, type of window it should be set to, current x and y positions, and window type
	; HWND_NOTOPMOST make it a normal window again
	; SWP_NOSIZE means to ignore the cx & cy variables (thus why they are both set to 0
	invoke SetWindowPos,hWin, HWND_NOTOPMOST, hxs, hys, 0, 0, SWP_NOSIZE
	
	ret
NoForceWindowTop endp

WndProc proc hWin:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM
	LOCAL rect:RECT
	
	invoke GetWindowRect,hWin,addr rect ; Get the current dimensions of the window/dialog box
	
	mov		eax,uMsg
	.if eax==WM_INITDIALOG
		push	hWin
		pop		hWnd
	.elseif eax==WM_COMMAND
		mov		eax,wParam
		and		eax,0FFFFh
		
		.if ax == IDC_START ; Was the "Start Timer" button clicked?
			invoke GetDlgItemInt,hWin,IDC_TIME,0,0 ; Get the time (in minutes) for the break, and convert it to an integer
			
			imul eax, 60 ; Multiply the minute(s) entered by 60 (60 seconds = 1 minute)
			
			mov buffer, eax ; Store the value of IDC_TIME into buffer

			.if buffer < 0 ; An error occured while trying to convert...so lets do it
				invoke MessageBox, hWin, addr NoTimeEntered, addr AppName, MB_OK
			.else ; Everything went fine...so lets get with the actual work
				xor ebx, ebx ; Make sure the EBX register is empty
					
				; While we still have seconds left in the buffer...
				.while buffer > 0
					add ebx, 1000 ; Add 1000 (one thousand) to the value in EBX (1000 milliseconds = 1 second)
					dec buffer       ; We took care of a second, so now we decrement the buffer by one
				.endw

				mov buffer, ebx ; Move the result of EBX into buffer

				invoke SetTimer,hWin,1,buffer,NULL ; Create a timer for our new value
			.endif
		.endif
	.elseif eax==WM_CLOSE
		invoke DestroyWindow,hWin
	.elseif uMsg==WM_DESTROY
		invoke PostQuitMessage,NULL
	.elseif uMsg==WM_TIMER
		; Force the window to be visible, unless either:
		; A) The window is minimized, B) The window is closed, or C) The message box "Ok" button is clicked
		invoke ForceWindowTop,hWin,rect.left,rect.bottom

		invoke MessageBox, hWin, addr TimerFinished, addr AppName, MB_OK ; Inform the user that their break has ended
		
		invoke KillTimer,hWin,1 ; Make sure the timer doesn't restart by destroying it
		
		; Remove the ForceWindowTop properties
		invoke NoForceWindowTop,hWin,rect.left,rect.bottom
	.else
		invoke DefWindowProc,hWin,uMsg,wParam,lParam
		ret
	.endif
	xor    eax,eax
	ret

WndProc endp

end start
